<%
/**
 * Copyright (c) 2000-2007 Liferay, Inc. All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
%>

<%@ include file="/html/portlet/communities/init.jsp" %>

<%
String tabs4 = (String)request.getAttribute("edit_pages.jsp-tab4");

long groupId = ((Long)request.getAttribute("edit_pages.jsp-groupId")).longValue();
boolean privateLayout = ((Boolean)request.getAttribute("edit_pages.jsp-privateLayout")).booleanValue();

String rootNodeName = (String)request.getAttribute("edit_pages.jsp-rootNodeName");

PortletURL portletURL = (PortletURL)request.getAttribute("edit_pages.jsp-portletURL");
%>

<liferay-ui:error exception="<%= LayoutImportException.class %>" message="an-unexpected-error-occurred-while-importing-your-file" />

<%
List portletsList = new ArrayList();
Set portletIdsSet = new HashSet();

Iterator itr1 = LayoutLocalServiceUtil.getLayouts(groupId, privateLayout).iterator();

while (itr1.hasNext()) {
	Layout curLayout = (Layout)itr1.next();

	if (curLayout.getType().equals(LayoutImpl.TYPE_PORTLET)) {
		LayoutTypePortlet curLayoutTypePortlet = (LayoutTypePortlet)curLayout.getLayoutType();

		Iterator itr2 = curLayoutTypePortlet.getPortletIds().iterator();

		while (itr2.hasNext()) {
			Portlet curPortlet = PortletLocalServiceUtil.getPortletById(company.getCompanyId(), (String)itr2.next());

			if (curPortlet != null) {
				PortletDataHandler portletDataHandler = curPortlet.getPortletDataHandlerInstance();

				if ((portletDataHandler != null) && !portletIdsSet.contains(curPortlet.getRootPortletId())) {
					portletIdsSet.add(curPortlet.getRootPortletId());

					portletsList.add(curPortlet);
				}
			}
		}
	}
}

Collections.sort(portletsList, new PortletTitleComparator(application, locale));

String tabs4Names = "export,import";

if ((layout.getGroupId() == groupId) && (layout.isPrivateLayout() == privateLayout)) {
	tabs4Names = "export";
}
%>

<liferay-ui:tabs
	names="<%= tabs4Names %>"
	param="tabs4"
	url="<%= portletURL.toString() %>"
/>

<c:choose>
	<c:when test='<%= tabs4.equals("export") %>'>
		<liferay-ui:message key="export-the-current-pages-to-the-given-lar-file-name" />

		<br /><br />

		<div>
			<input name="<portlet:namespace />exportFileName" size="50" type="text" value="<%= StringUtil.replace(rootNodeName, " ", "_") %>-<%= Time.getShortTimestamp() %>.lar">
		</div>

		<br />

		<liferay-ui:message key="what-would-you-like-to-export" />

		<div>
			<liferay-ui:input-checkbox param="<%= PortletDataHandlerKeys.EXPORT_PORTLET_PREFERENCES %>" defaultValue="<%= false %>" />

			<label for="<portlet:namespace /><%= PortletDataHandlerKeys.EXPORT_PORTLET_PREFERENCES %>Checkbox"><liferay-ui:message key="portlet-preferences" /></label>
		</div>

		<div>
			<liferay-ui:input-checkbox param="<%= PortletDataHandlerKeys.EXPORT_PORTLET_DATA %>" defaultValue="<%= false %>" />

			<label for="<portlet:namespace /><%= PortletDataHandlerKeys.EXPORT_PORTLET_DATA %>Checkbox"><liferay-ui:message key="portlet-data" /></label>
		</div>

		<div>
			<liferay-ui:input-checkbox param="<%= PortletDataHandlerKeys.EXPORT_PERMISSIONS %>" defaultValue="<%= false %>" />

			<label for="<portlet:namespace /><%= PortletDataHandlerKeys.EXPORT_PERMISSIONS %>Checkbox"><liferay-ui:message key="permissions" /></label>
		</div>

		<div>
			<liferay-ui:input-checkbox param="<%= PortletDataHandlerKeys.EXPORT_THEME %>" defaultValue="<%= false %>" />

			<label for="<portlet:namespace /><%= PortletDataHandlerKeys.EXPORT_THEME %>Checkbox"><liferay-ui:message key="root-theme" /> (<%= LanguageUtil.get(pageContext, "all-pages-will-use-the-exported-theme") %>)</label>
		</div>

		<%
		itr1 = portletsList.iterator();

		while (itr1.hasNext()) {
			Portlet curPortlet = (Portlet)itr1.next();

			PortletDataHandler portletDataHandler = curPortlet.getPortletDataHandlerInstance();

			PortletConfig curPortletConfig = PortletConfigFactory.create(curPortlet, application);

			ResourceBundle resourceBundle = curPortletConfig.getResourceBundle(locale);

			try {
				PortletDataHandlerControl[] controls = portletDataHandler.getExportControls();

				if (controls != null) {
		%>

					<fieldset>
						<legend><b><%= PortalUtil.getPortletTitle(curPortlet, application, locale) %></b></legend>
						<%= _renderControls(renderResponse.getNamespace(), resourceBundle, controls) %>
					</fieldset>

		<%
				}
			}
			catch (PortletDataException pde) {
			%>

				<fieldset>
					<legend><b><%= PortalUtil.getPortletTitle(curPortlet, application, locale) %></b></legend>
					<span class="portlet-msg-error"><%= LanguageUtil.get(pageContext, "error-initializing-export-controls") %></span>
				</fieldset>

		<%
			}
		}
		%>

		<br />

		<input type="button" value='<liferay-ui:message key="export" />'  onClick="<portlet:namespace />exportPages();" />
	</c:when>
	<c:when test='<%= tabs4.equals("import") %>'>
		<c:if test="<%= (layout.getGroupId() != groupId) || (layout.isPrivateLayout() != privateLayout) %>">
			<liferay-ui:message key="import-a-lar-file-to-overwrite-the-current-pages" />

			<br /><br />

			<div>
				<input name="<portlet:namespace />importFileName" size="50" type="file" />
			</div>

			<br />

			<liferay-ui:message key="what-would-you-like-to-import" />

			<div>
				<liferay-ui:input-checkbox param="<%= PortletDataHandlerKeys.IMPORT_PORTLET_PREFERENCES %>" defaultValue="<%= false %>" />

				<label for="<portlet:namespace /><%= PortletDataHandlerKeys.IMPORT_PORTLET_PREFERENCES %>Checkbox"><liferay-ui:message key="portlet-preferences" /></label>
			</div>

			<div>
				<liferay-ui:input-checkbox param="<%= PortletDataHandlerKeys.IMPORT_PORTLET_DATA %>" defaultValue="<%= false %>" />

				<label for="<portlet:namespace /><%= PortletDataHandlerKeys.IMPORT_PORTLET_DATA %>Checkbox"><liferay-ui:message key="portlet-data" /></label>
			</div>

			<div>
				<liferay-ui:input-checkbox param="<%= PortletDataHandlerKeys.IMPORT_PERMISSIONS %>" defaultValue="<%= false %>" />

				<label for="<portlet:namespace /><%= PortletDataHandlerKeys.IMPORT_PERMISSIONS %>Checkbox"><liferay-ui:message key="permissions" /></label>
			</div>

			<div>
				<liferay-ui:input-checkbox param="<%= PortletDataHandlerKeys.IMPORT_THEME %>" defaultValue="<%= false %>" />

				<label for="<portlet:namespace /><%= PortletDataHandlerKeys.IMPORT_THEME %>Checkbox"><liferay-ui:message key="root-theme" /></label>
			</div>

			<%
			itr1 = portletsList.iterator();

			while (itr1.hasNext()) {
				Portlet curPortlet = (Portlet)itr1.next();

				PortletDataHandler portletDataHandler = curPortlet.getPortletDataHandlerInstance();

				PortletConfig curPortletConfig = PortletConfigFactory.create(curPortlet, application);

				ResourceBundle resourceBundle = curPortletConfig.getResourceBundle(locale);

				try {
					PortletDataHandlerControl[] controls = portletDataHandler.getImportControls();

					if (controls != null) {
			%>

						<fieldset>
							<legend><b><%= PortalUtil.getPortletTitle(curPortlet, application, locale) %></b></legend>
							<%= _renderControls(renderResponse.getNamespace(), resourceBundle, controls) %>
						</fieldset>

			<%
					}
				}
				catch (PortletDataException pde) {
				%>

					<fieldset>
						<legend><b><%= PortalUtil.getPortletTitle(curPortlet, application, locale) %></b></legend>
						<span class="portlet-msg-error"><%= LanguageUtil.get(pageContext, "error-initializing-import-controls") %></span>
					</fieldset>

			<%
				}
			}
			%>

			<br />

			<input type="button" value="<liferay-ui:message key="import" />" onClick="<portlet:namespace />importPages();">
		</c:if>
	</c:when>
</c:choose>

<script type="text/javascript">
	jQuery(function(){
		jQuery(".<portlet:namespace />handler-control input[@type=checkbox]:not([@checked])").parent().parent().parent(".<portlet:namespace />handler-control").children(".<portlet:namespace />handler-control").hide();

		jQuery(".<portlet:namespace />handler-control input[@type=checkbox]").unbind('click').click(function() {
			var input = jQuery(this).parents(".<portlet:namespace />handler-control:first");

			if (this.checked) {
				input.children(".<portlet:namespace />handler-control").show();
			}
			else {
				input.children(".<portlet:namespace />handler-control").hide();
			}
		});
	});
</script>

<%!
private String _renderControls(String namespace, ResourceBundle resourceBundle, PortletDataHandlerControl[] controls) {
	StringMaker sm = new StringMaker();

	for (int i = 0; i < controls.length; i++) {
		sm.append("<div class=\"");
		sm.append(namespace);
		sm.append("handler-control\">");

		if (controls[i] instanceof PortletDataHandlerBoolean) {
			PortletDataHandlerBoolean control = (PortletDataHandlerBoolean)controls[i];

			sm.append("<label class=\"");
			sm.append(namespace);
			sm.append("handler-control-label\">");
			sm.append("<input ");
			sm.append(control.getDefaultState() ? "checked=\"checked\" " : "");
			sm.append("name=\"");
			sm.append(namespace);
			sm.append(control.getControlName());
			sm.append("\" ");
			sm.append("type=\"checkbox\" />");
			sm.append(resourceBundle.getString(control.getControlName()));
			sm.append("</label>");

			PortletDataHandlerControl[] children = control.getChildren();

			if (children != null) {
				sm.append(_renderControls(namespace, resourceBundle, children));
			}
		}
		else if (controls[i] instanceof PortletDataHandlerChoice) {
			PortletDataHandlerChoice control = (PortletDataHandlerChoice)controls[i];

			sm.append("<span class=\"");
			sm.append(namespace);
			sm.append("handler-control-label\">");
			sm.append("<strong>&#9632;</strong> ");
			sm.append(resourceBundle.getString(control.getControlName()));
			sm.append("</span>");

			String[] choices = control.getChoices();

			for (int j = 0; j < choices.length; j++) {
				sm.append("<label class=\"");
				sm.append(namespace);
				sm.append("handler-control-label\">");
				sm.append("<input ");
				sm.append(control.getDefaultChoiceIndex() == j ? "checked=\"checked\" " : "");
				sm.append("name=\"");
				sm.append(namespace);
				sm.append(control.getControlName());
				sm.append("\" type=\"radio\" value=\"");
				sm.append(choices[j]);
				sm.append("\" />");
				sm.append(resourceBundle.getString(choices[j]));
				sm.append("</label>");
			}
		}

		sm.append("</div>");
	}

	return sm.toString();
}
%>