<%
/**
 * Copyright (c) 2000-2007 Liferay, Inc. All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
%>

<%@ include file="/html/portlet/communities/init.jsp" %>

<%
Group group = (Group)request.getAttribute("edit_pages.jsp-group");
boolean privateLayout = ((Boolean)request.getAttribute("edit_pages.jsp-privateLayout")).booleanValue();
Layout selLayout = (Layout)request.getAttribute("edit_pages.jsp-selLayout");

String languageId = LanguageUtil.getLanguageId(request);
Locale languageLocale = LocaleUtil.fromLanguageId(languageId);

String name = request.getParameter("name");

if (Validator.isNull(name)) {
	name = selLayout.getName(languageLocale);
}

String title = request.getParameter("title");

if (Validator.isNull(title)) {
	title = selLayout.getTitle(languageLocale);
}

String type = BeanParamUtil.getString(selLayout, request, "type");
String friendlyURL = BeanParamUtil.getString(selLayout, request, "friendlyURL");
%>

<input name="<portlet:namespace />curLanguageId" type="hidden" value="<%= languageId %>" />

<table border="0" cellpadding="0" cellspacing="0" width="100%">
<tr>
	<td>
		<table class="liferay-table">
		<tr>
			<td>
				<liferay-ui:message key="name" />
			</td>
			<td>
				<table class="liferay-table">
				<tr>
					<td>
						<input name="<portlet:namespace />name" size="30" type="text" value="<%= name %>" />
					</td>
					<td>
						<select name="<portlet:namespace />languageId" onChange="<portlet:namespace />savePage();">

							<%
							Locale[] locales = LanguageUtil.getAvailableLocales();

							for (int i = 0; i < locales.length; i++) {
							%>

								<option <%= (languageId.equals(LocaleUtil.toLanguageId(locales[i]))) ? "selected" : "" %> value="<%= LocaleUtil.toLanguageId(locales[i]) %>"><%= locales[i].getDisplayName(locales[i]) %></option>

							<%
							}
							%>

						</select>
					</td>
				</tr>
				</table>
			</td>
		</tr>
		<tr>
			<td>
				<liferay-ui:message key="html-title" />
			</td>
			<td>
				<input name="<portlet:namespace />title" size="30" type="text" value="<%= title %>" />
			</td>
		</tr>
		<tr>
			<td colspan="2">
				<br />
			</td>
		</tr>
		<tr>
			<td>
				<liferay-ui:message key="type" />
			</td>
			<td>
				<select name="<portlet:namespace />type">

					<%
					for (int i = 0; i < LayoutImpl.TYPES.length; i++) {
					%>

						<option <%= type.equals(LayoutImpl.TYPES[i]) ? "selected" : "" %> value="<%= LayoutImpl.TYPES[i] %>"><%= LanguageUtil.get(pageContext, "layout.types." + LayoutImpl.TYPES[i]) %></option>

					<%
					}
					%>

				</select>
			</td>
		</tr>
		<tr>
			<td>
				<liferay-ui:message key="hidden" />
			</td>
			<td>
				<liferay-ui:input-checkbox param="hidden" defaultValue="<%= selLayout.isHidden() %>" />
			</td>
		</tr>

		<c:if test="<%= PortalUtil.isLayoutFriendliable(selLayout) %>">
			<tr>
				<td>
					<liferay-ui:message key="friendly-url" />
				</td>
				<td nowrap>

					<%
					StringMaker friendlyURLBase = new StringMaker();

					friendlyURLBase.append(PortalUtil.getPortalURL(request));

					String virtualHost = selLayout.getLayoutSet().getVirtualHost();

					if (Validator.isNull(virtualHost) || (friendlyURLBase.indexOf(virtualHost) == -1)) {
						friendlyURLBase.append(group.getPathFriendlyURL(privateLayout, themeDisplay));

						String parentFriendlyURL = group.getFriendlyURL();

						if (Validator.isNull(parentFriendlyURL)) {
							parentFriendlyURL = group.getDefaultFriendlyURL(privateLayout);
						}

						friendlyURLBase.append(parentFriendlyURL);
					}
					%>

					<%= friendlyURLBase.toString() %>

					<input name="<portlet:namespace />friendlyURL" size="30" type="text" value="<%= friendlyURL %>" /> <%= LanguageUtil.format(pageContext, "for-example-x", "<i>/news</i>") %>
				</td>
			</tr>
		</c:if>

		<tr>
			<td colspan="2">
				<br />
			</td>
		</tr>
		<tr>
			<td>
				<liferay-ui:message key="icon" />
			</td>
			<td>
				<liferay-theme:layout-icon layout="<%= selLayout %>" />

				<input name="<portlet:namespace />iconFileName" size="30" type="file" onChange="document.<portlet:namespace />fm.<portlet:namespace />iconImage.value = true; document.<portlet:namespace />fm.<portlet:namespace />iconImageCheckbox.checked = true;" />
			</td>
		</tr>
		<tr>
			<td>
				<liferay-ui:message key="use-icon" />
			</td>
			<td>
				<liferay-ui:input-checkbox param="iconImage" defaultValue="<%= selLayout.isIconImage() %>" />
			</td>
		</tr>
		</table>
	</td>
</tr>
<tr>
	<td>
		<div class="separator"><!-- --></div>
	</td>
</tr>
<tr>
	<td>

		<%
		request.setAttribute(WebKeys.SEL_LAYOUT, selLayout);
		%>

		<liferay-util:include page="<%= StrutsUtil.TEXT_HTML_DIR + PortalUtil.getLayoutEditPage(selLayout) %>" />
	</td>
</tr>
</table>

<br />

<input type="submit" value="<liferay-ui:message key="save" />" />

<liferay-security:permissionsURL
	modelResource="<%= Layout.class.getName() %>"
	modelResourceDescription="<%= selLayout.getName() %>"
	resourcePrimKey="<%= String.valueOf(selLayout.getPlid()) %>"
	var="permissionURL"
/>

<input type="button" value="<liferay-ui:message key="permissions" />" onClick="self.location = '<%= permissionURL %>';" />

<input type="button" value="<liferay-ui:message key="delete" />" onClick="<portlet:namespace />deletePage();" />

<script type="text/javascript">
	<c:if test="<%= renderRequest.getWindowState().equals(WindowState.MAXIMIZED) %>">
		Liferay.Util.focusFormField(document.<portlet:namespace />fm.<portlet:namespace />name);
	</c:if>

	function <portlet:namespace />getChoice(value) {
		for (var i = 0; i < document.<portlet:namespace />fm.<portlet:namespace />languageId.length; i++) {
			if (document.<portlet:namespace />fm.<portlet:namespace />languageId.options[i].value == value) {
				return document.<portlet:namespace />fm.<portlet:namespace />languageId.options[i].index;
			}
		}

		return null;
	}

	<%
	try {
		SAXReader reader = new SAXReader();

		Document doc = reader.read(new StringReader(selLayout.getName()));

		Element root = doc.getRootElement();

		String [] availableLocales = StringUtil.split(root.attributeValue("available-locales"));

		if (availableLocales != null) {
			for (int i = 0; i < availableLocales.length; i++) {
	%>

				document.<portlet:namespace />fm.<portlet:namespace />languageId.options[<portlet:namespace />getChoice("<%= availableLocales[i] %>")].style.color = "<%= colorScheme.getPortletMsgError() %>";

	<%
			}
		}
	}
	catch (Exception e) {
	}
	%>

</script>